/*
 * defines.h
 *
 *  Created on: Jul 20, 2011
 *      Author: Mariusz
 */

#ifndef DEFINES_H_
#define DEFINES_H_

#define GPIO_TCS3200 GPIOA			//
#define RCC_APB2Periph_TCS3200 RCC_APB2Periph_GPIOA

#define STRINGE(x,y) (x##y)
#define GPIO_Pin(x) \
	STRINGE(GPIO_Pin_,x)
#define GPIO_ODR_ODR(x) \
	STRINGE(GPIO_ODR_ODR,x)
#define GPIO_BSRR_BS(x) \
	STRINGE(GPIO_BSRR_BS,x)
#define GPIO_BSRR_BR(x) \
	STRINGE(GPIO_BSRR_BR,x)

#define TCS3200_PIN_S0 2	//
#define TCS3200_PIN_S1 3	//
#define TCS3200_PIN_S2 4	//
#define TCS3200_PIN_S3 5	//
#define TCS3200_PIN_OUT 0	//
#define TCS3200_PIN_nOE 6	//
#define TCS3200_PIN_LED 1	//

#define TCS3200_LED_ON \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BS(TCS3200_PIN_LED)
#define TCS3200_LED_OFF \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BR(TCS3200_PIN_LED)
#define TCS3200_LED_INV \
	((GPIO_TCS3200->ODR & GPIO_ODR_ODR(TCS3200_PIN_LED))?(TCS3200_LED_OFF):(TCS3200_LED_ON))
#define TCS3200_ENABLE \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BR(TCS3200_PIN_nOE)
#define TCS3200_DISABLE \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BS(TCS3200_PIN_nOE)

#define TCS3200_Red \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BR(TCS3200_PIN_S2) | GPIO_BSRR_BR(TCS3200_PIN_S3)
#define TCS3200_Blue \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BR(TCS3200_PIN_S2) | GPIO_BSRR_BS(TCS3200_PIN_S3)
#define TCS3200_Clear \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BS(TCS3200_PIN_S2) | GPIO_BSRR_BR(TCS3200_PIN_S3)
#define TCS3200_Green \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BS(TCS3200_PIN_S2) | GPIO_BSRR_BS(TCS3200_PIN_S3)

#define TCS3200_Freq_PowerDown \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BR(TCS3200_PIN_S0) | GPIO_BSRR_BR(TCS3200_PIN_S1)
#define TCS3200_Freq_2p \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BR(TCS3200_PIN_S0) | GPIO_BSRR_BS(TCS3200_PIN_S1)
#define TCS3200_Freq_20p \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BS(TCS3200_PIN_S0) | GPIO_BSRR_BR(TCS3200_PIN_S1)
#define TCS3200_Freq_100p \
	GPIO_TCS3200->BSRR = GPIO_BSRR_BS(TCS3200_PIN_S0) | GPIO_BSRR_BS(TCS3200_PIN_S1)


#endif /* DEFINES_H_ */
